/******************************************************************
esBit.cpp (operatori sui bit)

Scrivere un programma che
1- chiede in ingresso un numero intero non negativo n
2- genera una maschera M1 con il bit n-esimo a 1 e tutti gli altri bit a 0
3- stampa il valore numerico della  maschera
4- genera una maschera M2 con il bit n-esimo a 0 e tutti gli altri bit a 1
5- stampa il valore numerico della  maschera
Notare che il primo bit della maschera ha posizione 0, il secondo 1, ecc.

L'output deve essere del tipo:

Inserisci n: 3
Valore numerico della maschera M1: 8
Valore numerico della maschera M2: 65527

Nota: il secondo valore potrebbe variare da calcolatore a calcolatore.
Esso infatti dipende da quanti bit occupa un unsigned short int,
ossia dal valore di sizeof(unsigned short int):

65527 e' il risultato che si ottiene quando sizeof(unsigned short int) vale 2
4294967287 sarebbe il risultato che si otterrebbe qualora sizeof(unsigned short int) fosse 4

*******************************************************/

#include <iostream>
using namespace std;

int main() {

   cout << "Inserisci n: ";
   unsigned short int n;
   cin >> n;
   unsigned short int m1 = 1u << n;  // maschera a 16 bit ( 1u e' la costante letterale "uno" per il tipo unsigned)

   cout << "Valore numerico della maschera M1: " << m1 << endl;
   // La prossima istruzione serve a fare in modo che d'ora in avanti i naturali 
   // verranno mostrati a video in base sedici.
   // Per tornare a visualizzare i natarali in base 10, utilizzare lo statement cout<<dec;
   cout << hex;
   cout << "Visualizzato in base 16: " << m1 << endl;
   cout << dec;

   unsigned short int m2 = ~(1u << n);  // oppure m2 = ~m1
   cout << "Valore numerico della maschera M2: " << m2 << endl;
   cout << hex;
   cout << "Visualizzato in base 16: " << m2 << endl;
   cout << dec;

   return 0;
}
